#ifndef _BINARY_H // -*-C++-*-
#define _BINARY_H

#include <Heap.h>
#include <stdio.h>
#include <KayaAPI.h>

typedef unsigned char BYTE;

extern "C" {
    void* newBlock(int size);
    void poke(void* block,int offset,int val);
    int peek(void* block,int offset);

    void pokestring(void* block, int offset, wchar_t* str);
    wchar_t* peekstring(void* block, kint offset, kint bsize);

    void* copyBlock(void* block,int size);
    void* copyChunk(void* block,int offset,int size);

    KayaArray getBlockData(void* block, int offset,int size);
    void setBlockData(void* block, int offset, int size, KayaArray data);

    int writeBlock(void* fptr,void* block, int size);
    void* readBlock(void* fptr, KayaValue size);

    wchar_t* b64binary(void* block, int len);
    void* b64binarydec(wchar_t* block, KayaValue len);
}

#endif
